// +build !ignore_autogenerated

/*
Copyright 2017 The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// This file was autogenerated by deepcopy-gen. Do not edit it manually!

package ingress

import (
	v1 "k8s.io/api/core/v1"
	conversion "k8s.io/apimachinery/pkg/conversion"
	reflect "reflect"
)

// GetGeneratedDeepCopyFuncs returns the generated funcs, since we aren't registering them.
func GetGeneratedDeepCopyFuncs() []conversion.GeneratedDeepCopyFunc {
	return []conversion.GeneratedDeepCopyFunc{
		{Fn: DeepCopy__Backend, InType: reflect.TypeOf(&Backend{})},
		{Fn: DeepCopy__CookieSessionAffinity, InType: reflect.TypeOf(&CookieSessionAffinity{})},
		{Fn: DeepCopy__Endpoint, InType: reflect.TypeOf(&Endpoint{})},
		{Fn: DeepCopy__SessionAffinityConfig, InType: reflect.TypeOf(&SessionAffinityConfig{})},
	}
}

// DeepCopy__Backend is an autogenerated deepcopy function.
func DeepCopy__Backend(in interface{}, out interface{}, c *conversion.Cloner) error {
	{
		in := in.(*Backend)
		out := out.(*Backend)
		*out = *in
		if in.Service != nil {
			in, out := &in.Service, &out.Service
			if newVal, err := c.DeepCopy(*in); err != nil {
				return err
			} else {
				*out = newVal.(*v1.Service)
			}
		}
		if in.Endpoints != nil {
			in, out := &in.Endpoints, &out.Endpoints
			*out = make([]Endpoint, len(*in))
			for i := range *in {
				if err := DeepCopy__Endpoint(&(*in)[i], &(*out)[i], c); err != nil {
					return err
				}
			}
		}
		if err := DeepCopy__SessionAffinityConfig(&in.SessionAffinity, &out.SessionAffinity, c); err != nil {
			return err
		}
		return nil
	}
}

// DeepCopy__CookieSessionAffinity is an autogenerated deepcopy function.
func DeepCopy__CookieSessionAffinity(in interface{}, out interface{}, c *conversion.Cloner) error {
	{
		in := in.(*CookieSessionAffinity)
		out := out.(*CookieSessionAffinity)
		*out = *in
		if in.Locations != nil {
			in, out := &in.Locations, &out.Locations
			*out = make(map[string][]string)
			for key, val := range *in {
				if newVal, err := c.DeepCopy(&val); err != nil {
					return err
				} else {
					(*out)[key] = *newVal.(*[]string)
				}
			}
		}
		return nil
	}
}

// DeepCopy__Endpoint is an autogenerated deepcopy function.
func DeepCopy__Endpoint(in interface{}, out interface{}, c *conversion.Cloner) error {
	{
		in := in.(*Endpoint)
		out := out.(*Endpoint)
		*out = *in
		if in.Target != nil {
			in, out := &in.Target, &out.Target
			*out = new(v1.ObjectReference)
			**out = **in
		}
		return nil
	}
}

// DeepCopy__SessionAffinityConfig is an autogenerated deepcopy function.
func DeepCopy__SessionAffinityConfig(in interface{}, out interface{}, c *conversion.Cloner) error {
	{
		in := in.(*SessionAffinityConfig)
		out := out.(*SessionAffinityConfig)
		*out = *in
		if err := DeepCopy__CookieSessionAffinity(&in.CookieSessionAffinity, &out.CookieSessionAffinity, c); err != nil {
			return err
		}
		return nil
	}
}
